#include "Cursor.h"

Cursor::Cursor(void)
{
	mPosX=mPosY=0;

	mCursor[0].setPosition(228,36);
	mCursor[1].setPosition(232,36);
	mCursor[2].setPosition(230,34);
	mCursor[3].setPosition(230,38);

	mCursor[0].setDimention(2,2);
	mCursor[1].setDimention(2,2);
	mCursor[2].setDimention(2,2);
	mCursor[3].setDimention(2,2);

	mCursor[0].setColor(0xF00F);
	mCursor[1].setColor(0xF00F);
	mCursor[2].setColor(0xF00F);
	mCursor[3].setColor(0xF00F);

	mDimX=mDimY=100;
}

Cursor::~Cursor(void)
{
}

void Cursor::translate(short x,short y)
{
	mPosX+=x;
	mPosY+=y;
	if(mPosX<0) mPosX=0;
	if(mPosY<0) mPosY=0;
	if(mPosX>mDimX-1) mPosX=mDimX-1;
	if(mPosY>mDimY-1) mPosY=mDimY-1;

	short baseX=240-mDimX;
	short baseY=136-mDimY;

	mCursor[0].setPosition(2*mPosX+baseX-2,2*mPosY+baseY);
	mCursor[1].setPosition(2*mPosX+baseX+2,2*mPosY+baseY);
	mCursor[2].setPosition(2*mPosX+baseX,2*mPosY+baseY-2);
	mCursor[3].setPosition(2*mPosX+baseX,2*mPosY+baseY+2);
}

void Cursor::render()
{
	mCursor[0].render();
	mCursor[1].render();
	mCursor[2].render();
	mCursor[3].render();
}

void Cursor::setDimention(short width,short height)
{
	mDimX=width;
	mDimY=height;

	short baseX=240-mDimX;
	short baseY=136-mDimY;

	mCursor[0].setPosition(2*mPosX+baseX-2,2*mPosY+baseY);
	mCursor[1].setPosition(2*mPosX+baseX+2,2*mPosY+baseY);
	mCursor[2].setPosition(2*mPosX+baseX,2*mPosY+baseY-2);
	mCursor[3].setPosition(2*mPosX+baseX,2*mPosY+baseY+2);
}

short Cursor::getPosX()
{
	return mPosX;
}

short Cursor::getPosY()
{
	return mPosY;
}
