#pragma once
#include "Cell.h"
#include "Vertex.h"

class CellManager
{
public:
	CellManager(void);
	~CellManager(void);

	void initalise(unsigned char width,unsigned char height);
	unsigned char getWidth();
	unsigned char getHeight();

	void setAlive(unsigned char x,unsigned char y);
	void setDeath(unsigned char x,unsigned char y);

	void update();

	void clear();

	void render();

	void saveState();
	void loadState();

	void saveFile();
	void loadFile();
private:
	unsigned char mWidth,mHeight;
	Cell *mGrid;
	bool mSave[136][240];
};
